<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../paper-input/paper-input.html">
<link rel="import" href="../paper-button/paper-button.html">
<link rel="import" href="../iron-icon/iron-icon.html">
<link rel="import" href="../iron-icons/iron-icons.html">

<dom-module id="fotosocial-register">
  <template>
    <style>
      :host {
        display: block;
      }

      .container {
        display: flex;
        flex-direction: column;
        background-color: #F2F2F2;
        padding: 20px;
        border: 1px solid;
        @apply --fotosocial-register-container;
      }

      .button-container {
        display: flex;
        flex-direction: column;
        align-items: flex-end;
      }

      paper-button {
        width: 200px;
      }

      .user-exist {
        color: red;
      }
    </style>
    <div class="container">
      <paper-input label="Usuario" value="{{user::input}}">
        <iron-icon icon="account-circle" slot="suffix"></iron-icon>
      </paper-input>
      <paper-input label="Contraseña" value="{{password::input}}" type="password">
        <iron-icon icon="lock" slot="suffix"></iron-icon>
      </paper-input>
      <paper-input label="Confirmar contraseña" value="{{passwordConfirm::input}}" type="password">
        <iron-icon icon="lock" slot="suffix"></iron-icon>
      </paper-input>
      <div class="button-container">
        <div hidden$="[[userExist]]" class="user-exist">Usuario Repetido</div>
        <paper-button disabled="[[registerDisabled]]" raised on-click="_clickRegister">
          Registrar
        </paper-button>
        <paper-button on-click="_goToLogin">
          Regresar
        </paper-button>
      </div>
    </div>
  </template>

  <script>
    /**
     * `fotosocial-register`
     * registro de usuarios del proyecto
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialRegister extends Polymer.Element {
      static get is() { return 'fotosocial-register'; }
      static get properties() {
        return {
          user: {
            type: String,
            value: ''
          },
          password: {
            type: String,
            value: ''
          },
          passwordConfirm: {
            type: String,
            value: ''
          },
          registerDisabled: {
            type: Boolean,
            value: true,
            computed: '_validate(user, password, passwordConfirm)'
          },
          userExist: {
            type: Boolean,
            value: true
          }
        };
      }

      _validate(user, password, passwordConfirm) {
        return user !== '' && password !== '' && password === passwordConfirm ? false : true;
      }

      _goToLogin() {
        this.dispatchEvent(new CustomEvent('click-go-to-login',{
          bubbles: true,
          composed: true,
          detail: 'fotosocialLogin'
        }));
      }

      _clickRegister() {
        this.set('userExist', true);
        this.dispatchEvent(new CustomEvent('click-register',{
          bubbles: true,
          composed: true,
          detail: {
            user: this.user,
            password: this.password
          }
        }));
      }


    }

    window.customElements.define(FotosocialRegister.is, FotosocialRegister);
  </script>
</dom-module>
